#include<iostream>
#include<algorithm>
using namespace std;
typedef long long ll;
typedef unsigned int uint;



template<int N>
struct ftree {
	ll data[N];
	
	
	ll get(int pos) {
		if(pos == 0)
			return 0;
		
		return data[pos] + get(pos - (pos & -pos) );
	}
	
	
	void add(int pos, int toadd) {
		if(pos >= N)
			return;
		
		data[pos] += toadd;
		add(pos + (pos & -pos), toadd);
	}
};



//Here we deal with the Y dimension.

ftree<501> ft[501];


ll sget(int y, int x) {
	if(y == 0)
		return 0;
	
	return ft[y].get(x)  +  sget(y - (y & -y), x );
}



void sadd(int y, int x, int toadd) {
	if(y >= 501)
		return;
		
	ft[y].add(x, toadd);
	sadd(y + (y & -y), x, toadd);
};



ll getrect(int y1, int y2, int x1, int x2) {
	return sget(y2, x2) - sget(y2, x1-1) - sget(y1-1, x2) + sget(y1-1, x1-1);
}






//--------------------------------------------------------------------------------
//Main function here

int n, m ,q, o, p1, p2, p3, p4;




int main() {
	cin.sync_with_stdio(false);
	
	cin >> n >> m;
	
	for(int i=0;i<n;i++)
		for(int j=0;j<m;j++)
			cin >> p1, sadd(i+1, j+1, p1);
	
	cin >> q;
	
	for(int op=0;op<q;op++) {
		cin >> o;
		
		if(o == 1) {
			cin >> p1 >> p2 >> p3;
			
			sadd(p1, p2, p3);
		}
		
		if(o == 2) {
			cin >> p1 >> p2 >> p3;
			
			sadd(p1, p2, p3 - getrect(p1, p1, p2, p2) );
		}
		
		if(o == 3) {
			cin >> p1 >> p2 >> p3 >> p4;
			cout << getrect(p1, p2, p3, p4) << '\n';
		}
	}
	
	return 0;
}




































